<?
/*
=====================================================
 : addcomments.php
-----------------------------------------------------
 :     
=====================================================
*/
if(!defined('DATALIFEENGINE') OR $config['allow_comments'] != "yes")
{
  die("Hacking attempt!");
}
include(ENGINE_DIR.'/inc/parse.class.php');

$parse = new ParseFilter();
$parse->safe_mode = true;

$name = $db->safesql($parse->process(trim($_POST['name'])));
if($config['charset']=='utf-8') $name=iconv('utf-8','windows-1251',$name);
$mail = $db->safesql($parse->process(trim($_POST['mail'])));
$post_id = intval($_POST['post_id']);
$stop = array ();

if ($is_logged)
{
    $name = $member_id['name'];
    $mail = $member_id['email'];
}

	if ($_SERVER['HTTP_X_FORWARDED_FOR']) $_IP = $db->safesql($_SERVER['HTTP_X_FORWARDED_FOR']); else $_IP = $db->safesql($_SERVER['REMOTE_ADDR']);
	
	
	if ($config['allow_comments_wysiwyg'] != "yes")
		$comments = $db->safesql($parse->BB_Parse($parse->process($_POST['comments']), false));
	else{
		$parse->wysiwyg = true;
		$parse->ParseFilter(Array('div', 'a', 'span', 'p', 'br'), Array(), 0, 1);
		$comments = $db->safesql($parse->BB_Parse($parse->process($_POST['comments'])));
	}
	if($config['charset']=='utf-8') $comments=iconv('utf-8','windows-1251',$comments);
	$comments    = word_filter($comments);

	if (!$user_group[$member_id['user_group']]['captcha']) {
		$_SESSION['sec_code_session'] = 1;
		$_REQUEST['sec_code'] = 1;
	}

    if( strlen($name) > 50){
		$stop[] = $lang['news_err_1'];
        $CN_HALT = TRUE;
    }

    if( strlen($mail) > 50 AND !$is_logged){
		$stop[] = $lang['news_err_2'];
        $CN_HALT = TRUE;
    }
    if(!$post_id){
		$stop[] = $lang['news_err_id'];
       $CN_HALT = TRUE;
    }
    if( strlen($comments) > 3000){
		$stop[] = $lang['news_err_3'];
        $CN_HALT = TRUE;
    } 
    //echo "\n\n<!-- ".print_r($_REQUEST)."-->\n\n";
    if ($_REQUEST['sec_code'] != $_SESSION['sec_code_session'] OR !$_SESSION['sec_code_session']) {
		$stop[] = $lang['news_err_30'];
        $CN_HALT = TRUE;
    }

    if ($comments ==''){
		$stop[] = $lang['news_err_11'];
        $CN_HALT = TRUE;
    }

	//    
    if($member_id['user_group'] > 2 AND intval ($config['flood_time']) AND !$CN_HALT){
        if(flooder($_IP) == TRUE ){
		$stop[] = $lang['news_err_4']." ".$lang['news_err_5']." {$config['flood_time']} ".$lang['news_err_6'];
		$CN_HALT = TRUE;
        }
    }

	//    
	$row = $db->super_query("SELECT id, allow_comm, approve, access from " . PREFIX . "_post WHERE id='$post_id'");
	$options = news_permission ($row['access']);

	if ((!$user_group[$member_id['user_group']]['allow_addc'] AND $options[$member_id['user_group']] != 2) OR $options[$member_id['user_group']] == 1) die("Hacking attempt!");

	if (!$row['id'] OR !$row['allow_comm'] OR !$row['approve']) {
	$stop[] = $lang['news_err_29'];
	$CN_HALT = TRUE;
	}

	//     
	if (!$is_logged and $CN_HALT != TRUE) {
	$db->query("SELECT name from " . PREFIX . "_users where LOWER(name) = '".strtolower($name)."'");

	 if ($db->num_rows() > 0) {
	 $stop[] = $lang['news_err_7'];
	 $CN_HALT = TRUE;
     }
	$db->free();
    }



    if (empty($name) and $CN_HALT != TRUE) {
	    $stop[] = $lang['news_err_9'];
        $CN_HALT = TRUE;
    }

    if($mail != "")
    { $ok = FALSE;
        if(preg_match("/^[\.A-z0-9_\-]+[@][A-z0-9_\-]+([.][A-z0-9_\-]+)+[A-z]{1,4}$/", $mail)) $ok = TRUE;
        elseif($config['allow_url_instead_mail'] == "yes" and preg_match("/((http(s?):\/\/)|(www\.))([\w\.]+)([\/\w+\.-?]+)/", $mail)) $ok = TRUE;
        elseif($config['allow_url_instead_mail'] != "yes"){
              $stop[] = $lang['news_err_10'];
              $CN_HALT = TRUE;
        }
        else{
              $stop[] = $lang['news_err_10'];
              $CN_HALT = TRUE;
        }
    }

	//*   
    if(intval($config['auto_wrap'])){
		$comments = preg_replace("#([^\s<>'\"/\.\\-\?&\n\r\%]{".intval($config['auto_wrap'])."})#i", "\\1<br />" ,$comments);
    }

	$time = date ("Y-m-d H:i:s", (time()+$config['date_adjust']*60));

	//  
    if ($CN_HALT) {

            msgbox ($lang['all_err_1'], implode("<br />", $stop)."<br/><br/>");

    } else {

	 $_SESSION['sec_code_session'] = 0;
	 $update_comments = false;

	 $row = $db->super_query("SELECT * FROM " . PREFIX . "_comments WHERE post_id = '$post_id' ORDER BY id DESC LIMIT 0,1");

	 if ($row['id']) {

		if ($row['user_id'] == $member_id['user_id'] AND $row['is_register']) $update_comments = true;
		elseif ($row['autor'] == $name AND !$row['is_register']) $update_comments = true; // maqk edit )

		if ((strlen($row['text']) + strlen($comments)) > 3000) 
		{ 
			$update_comments = false;
			$stop[] = $lang['news_err_3'];
	        $CN_HALT = TRUE;
		}

	 }

  if (!$CN_HALT) {

	 if ($update_comments) {

		 $comments = $row['text']."<br /><br />".$comments;
		 $db->query("UPDATE " . PREFIX . "_comments set text='{$comments}' WHERE id='{$row['id']}'");

	 }
	 else {

		 if ($is_logged)
			 $db->query("INSERT INTO " . PREFIX . "_comments (post_id, user_id, date, autor, email, text, ip, is_register) values ('$post_id', '$member_id[user_id]', '$time', '$name', '$mail', '$comments', '$_IP', '1')");
		 else
			 $db->query("INSERT INTO " . PREFIX . "_comments (post_id, date, autor, email, text, ip, is_register) values ('$post_id', '$time', '$name', '$mail', '$comments', '$_IP', '0')");

		 //      
		 $db->query("UPDATE " . PREFIX . "_post set comm_num=comm_num+1 where id='$post_id'");

		 //      
		 if ($is_logged) {
			 $db->query("UPDATE " . PREFIX . "_users set comm_num=comm_num+1 where user_id ='$member_id[user_id]'");
		 }
	}

	 //   
	 if($config['flood_time'] != 0 and $config['flood_time'] != "") 
	 {
		 $time = time()+($config['date_adjust']*60);
		 $db->query("INSERT INTO " . PREFIX . "_flood (id, ip) values ('$time', '$_IP')");
	 }

	clear_cache ();
	if (!$ajax_adds) { header("Location: {$_SERVER['REQUEST_URI']}");}

  } else msgbox ($lang['all_err_1'], implode("<br />", $stop)."<br /><br />");

}

?>