<?php
/*
=====================================================
 : register.php
-----------------------------------------------------
 :  
=====================================================
*/

if(!defined('DATALIFEENGINE'))
{
  die("Hacking attempt!");
}

require_once (ENGINE_DIR.'/inc/parse.class.php');

$parse = new ParseFilter();
$parse->safe_mode = true;
$stopregistration = FALSE;

if (isset ($_REQUEST['doaction'])) $doaction = $_REQUEST['doaction']; else $doaction = "";
$config['reg_group'] = intval($config['reg_group']) ? intval($config['reg_group']) : 4;

function check_reg ($name, $email, $password1, $password2, $sec_code=1, $sec_code_session=1) {
	global $lang, $db;
	$stop = "";

    if ( $sec_code != $sec_code_session OR !$sec_code_session) $stop .= $lang['reg_err_19'];
	if ($password1 != $password2) $stop .= $lang['reg_err_1'];
	if (strlen($password1) < 6) $stop .= $lang['reg_err_2'];
	if (strlen($name) > 20) $stop .= $lang['reg_err_3'];
	if (preg_match("/[\||\'|\<|\>|\"|\!|\$|\@|\&\~\*\+]/",$name)) $stop .= $lang['reg_err_4'];
	//if ((!ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'. '@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email)) or (empty($email))) $stop .= $lang['reg_err_6'];
	if ((!ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'. '@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.'[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email)) and (!empty($email))) $stop .= $lang['reg_err_6'];
	if (empty($name)) $stop .= $lang['reg_err_7'];

	if ($stop == "")
	{
		//$row = $db->super_query ("SELECT COUNT(*) as count FROM " . PREFIX . "_users WHERE email = '$email' OR name ='$name'");
		$row = $db->super_query ("SELECT COUNT(*) as count FROM " . PREFIX . "_users WHERE name ='$name'");

        if ($row['count']) $stop .= $lang['reg_err_8'];
	}

return $stop;

}


$row = $db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_users");

 if ($config['allow_registration'] != "yes") 
 { 

	msgbox ($lang['all_info'], $lang['reg_err_9']); 
    $stopregistration = TRUE;

 } elseif ($config['max_users'] > 0 AND $row['count'] > $config['max_users']) { 

	msgbox ($lang['all_info'], $lang['reg_err_10']); 
    $stopregistration = TRUE;

 }


if (isset($_POST['submit_reg'])) {

	if ($config['allow_sec_code'] == "yes") {
		$sec_code = $_POST['sec_code'];
		$sec_code_session = ($_SESSION['sec_code_session'] != '') ? $_SESSION['sec_code_session'] : false;
	} else {
		$sec_code = 1;
		$sec_code_session = 1;
	}

	$password1 = $db->safesql($parse->process($_POST['password1']));
	$password2 = $db->safesql($parse->process($_POST['password2']));
	
	if($config['charset']=='utf-8')
	$name = $db->safesql($parse->process(iconv('utf-8','windows-1251',$_POST['name'])));
	else
	$name = $db->safesql($parse->process($_POST['name']));
	
	$email = $db->safesql($parse->process($_POST['email']));

	$reg_error = check_reg ($name, $email, $password1, $password2, $sec_code, $sec_code_session);

	if (!$reg_error) {

		if ($config['registration_type']) {

	         include_once ENGINE_DIR.'/inc/mail.class.php';
	         $mail = new dle_mail ($config);

			 $row = $db->super_query("SELECT template FROM " . PREFIX . "_email where name='reg_mail' LIMIT 0,1");

			 $row['template'] = stripslashes($row['template']);

			 $idlink = urlencode(base64_encode($name."||".$email."||".md5($password1)."||".md5($config['key'])));

			 $row['template'] = str_replace("{%username%}",$name, $row['template']);
			 $row['template'] = str_replace("{%validationlink%}",$config['http_home_url']."index.php?do=register&doaction=validating&id=".$idlink, $row['template']);
			 $row['template'] = str_replace("{%password%}", $password1, $row['template']);

             $mail->send ($email, $lang['reg_subj'], $row['template']);

             if ($mail->send_error) msgbox ($lang['all_info'], $mail->smtp_msg);
	         else msgbox ($lang['reg_vhead'], $lang['reg_vtext']);

 			 $stopregistration = TRUE;

		} else {

			$doaction = "validating";
			$_REQUEST['id'] = urlencode(base64_encode($name."||".$email."||".md5($password1)."||".md5($config['key'])));
		}

	} else {msgbox ($lang['reg_err_11'], $reg_error);}

}



if ($doaction != "validating" AND !$stopregistration) {

	$tpl->load_template('registration.tpl');

        $tpl->set('[registration]',"");
        $tpl->set('[/registration]',"");
		$tpl->set_block("'\\[validation\\](.*?)\\[/validation\\]'si","");
		$path = parse_url($config['http_home_url']);

	if ($config['allow_sec_code'] == "yes") {
        $tpl->set('[sec_code]',"");
        $tpl->set('[/sec_code]',"");
		$tpl->set('{reg_code}',"<img src=\"/antibot.php?".rand(1000,9999)."\" alt=\"${lang['sec_image']}\"/>");
	} else {
        $tpl->set('{reg_code}',"");
		$tpl->set_block("'\\[sec_code\\](.*?)\\[/sec_code\\]'si","");
	}


$tpl->copy_template = "<form  method=\"post\" action=\"?do=register\">\n<fieldset>".$tpl->copy_template."
<input name=\"submit_reg\" type=\"hidden\" value=\"submit_reg\"/>
</fieldset></form>";

$tpl->compile('content');
$tpl->clear();

}

if (isset($_POST['submit_val'])) {

	if($config['charset']=='utf-8')
	$fullname = $db->safesql($parse->process(iconv('utf-8','windows-1251',$_POST['fullname'])));
	else
	$fullname = $db->safesql($parse->process($_POST['fullname']));
		
	
	if($config['charset']=='utf-8')
	$land = $db->safesql($parse->process(iconv('utf-8','windows-1251',$_POST['land'])));
	else
	$land = $db->safesql($parse->process($_POST['land']));
		
	if($config['charset']=='utf-8')	
	$icq = $db->safesql($parse->process(iconv('utf-8','windows-1251',$_POST['icq'])));
	else
	$icq = $db->safesql($parse->process($_POST['icq']));
	
	if($config['charset']=='utf-8')
	$info = $db->safesql($parse->BB_Parse($parse->process(iconv('utf-8','windows-1251',$_POST['info'])), false));
	else
	$info = $db->safesql($parse->BB_Parse($parse->process($_POST['info']), false));

    $image = $_FILES['image']['tmp_name'];
    $image_name = $_FILES['image']['name'];
	$image_size = $_FILES['image']['size'];
    $image_name  = str_replace(" ", "_", $image_name);
	$img_name_arr = explode(".",$image_name);
	$type         = end($img_name_arr);

	$user_arr = explode ("||", base64_decode(urldecode($_POST['id'])));
	$user = trim($db->safesql($user_arr[0]));
	$pass = md5($user_arr[2]);

	$db->query("SELECT * FROM " . PREFIX . "_users where name = '$user' AND password='$pass'");

	if (!$db->num_rows()) $stop .= "Access Denied"; else $row = $db->get_row();

	$db->free();

	if (is_uploaded_file($image) AND !$stop) {

		if ($image_size < 100000) {

			$allowed_extensions = array("jpg", "png", "jpe", "jpeg", "gif");

				if ((in_array($type, $allowed_extensions) or in_array(strtolower($type), $allowed_extensions)) and $image_name) {

				include_once ENGINE_DIR.'/inc/makethumb.php';

				$res = @move_uploaded_file($image, ROOT_DIR."/uploads/fotos/".$row['user_id'].".".$type);

					if ($res) {

						$thumb=new thumbnail(ROOT_DIR."/uploads/fotos/".$row['user_id'].".".$type);
						$thumb->size_auto($user_group[$config['reg_group']]['max_foto']);	
						$thumb->jpeg_quality($config['jpeg_quality']);
						$thumb->save(ROOT_DIR."/uploads/fotos/foto_".$row['user_id'].".".$type);

						@unlink (ROOT_DIR."/uploads/fotos/".$row['user_id'].".".$type);
						$foto_name = "foto_".$row['user_id'].".".$type;

						$db->query("UPDATE " . PREFIX . "_users set foto='$foto_name' where name='$user'");

					} else $stop = $lang['reg_err_12'];
				} else $stop = $lang['reg_err_13'];
		} else $stop = $lang['news_err_16'];
	}

		if (strlen($info) > 500) $stop .= $lang['reg_err_14'];
		if (strlen($fullname) > 100) $stop .= $lang['reg_err_15'];
		if (strlen($land) > 100) $stop .= $lang['reg_err_16'];
		if (strlen($icq) > 20) $stop .= $lang['reg_err_17'];

	if ($stop){ msgbox ($lang['reg_err_18'], $stop); }
	else {

	$xfieldsaction = "init";
	$xfieldsadd = true;
	include(ENGINE_DIR.'/inc/userfields.php');
	$filecontents = array ();

    if (!empty($postedxfields)) {
      foreach ($postedxfields as $xfielddataname => $xfielddatavalue) {
        if (!$xfielddatavalue) { continue;}

		$xfielddatavalue = $db->safesql($parse->BB_Parse($parse->process($xfielddatavalue), false));

        $xfielddataname = $db->safesql($xfielddataname);

        $xfielddataname = str_replace("|", "&#124;", $xfielddataname);
        $xfielddatavalue = str_replace("|", "&#124;", $xfielddatavalue);
		$filecontents[] = "$xfielddataname|$xfielddatavalue";
      }

      $filecontents = implode("||", $filecontents);
	} else $filecontents = '';

		$db->query("UPDATE " . PREFIX . "_users set fullname='$fullname', info='$info', land='$land', icq='$icq', xfields='$filecontents' where name='$user'");

		msgbox ($lang['reg_ok'], $lang['reg_ok_1']);

		$stopregistration = TRUE;
	}
}


if ( ($doaction == "validating") AND (!$stopregistration) AND (!$_POST['submit_val']) ) {

	$user_arr = explode ("||", base64_decode(urldecode($_REQUEST['id'])));

	$regpassword = md5($user_arr[2]);
	$name = trim($db->safesql($parse->process($user_arr[0])));
	$email = trim($db->safesql($parse->process($user_arr[1])));

	if (md5($config['key']) != $user_arr[3]) die ('ID not valid!');

	$reg_error = check_reg($name, $email, $regpassword, $regpassword);

	if ($reg_error != "") { 
		msgbox ($lang['reg_err_11'], $reg_error); 
		$stopregistration = TRUE; 
	} else {

	if (($_REQUEST['step'] != 2) AND $config['registration_type']) {
		$stopregistration = TRUE;
		$lang['confirm_ok'] = str_replace ('{email}', $email, $lang['confirm_ok']);
		$lang['confirm_ok'] = str_replace ('{login}', $name, $lang['confirm_ok']);
		msgbox ($lang['all_info'], $lang['confirm_ok']. "<br /><br /><a href=\"".$config['http_home_url']."index.php?do=register&doaction=validating&step=2&id=".urlencode($_REQUEST['id'])."\">   </a>"); 
	} else {

    $add_time = time()+($config['date_adjust']*60);
	if ($_SERVER['HTTP_X_FORWARDED_FOR']) $_IP = $db->safesql($_SERVER['HTTP_X_FORWARDED_FOR']); else $_IP = $db->safesql($_SERVER['REMOTE_ADDR']);

    $db->query("INSERT INTO " . PREFIX . "_users (name, password, email, reg_date, lastdate, user_group, logged_ip) VALUES ('$name', '$regpassword', '$email', '$add_time', '$add_time', '".$config['reg_group']."', '".$_IP."')");
	}

  }

}

if ($doaction == "validating" AND !$stopregistration) {

	$tpl->load_template('registration.tpl');

        $tpl->set('[validation]',"");
        $tpl->set('[/validation]',"");
		$tpl->set_block("'\\[registration\\].*?\\[/registration\\]'si","");

		  $xfieldsaction = "list";
		  $xfieldsadd = true;
		  include(ENGINE_DIR.'/inc/userfields.php');
          $tpl->set('{xfields}',$output);


$tpl->copy_template = "<form method=\"post\" action=\"".$PHP_SELF."\">\n<fieldset>".$tpl->copy_template."
<input name=\"submit_val\" type=\"hidden\" value=\"submit_val\"/>
<input name=\"do\" type=\"hidden\" value=\"register\"/>
<input name=\"doaction\" type=\"hidden\" value=\"validating\"/>
<input name=\"id\" type=\"hidden\" value=\"{$_REQUEST['id']}\"/>
</fieldset></form>";

	$tpl->compile('content');
	$tpl->clear();
}

?>