<?PHP
/*
=====================================================
 : functions.inc.php
-----------------------------------------------------
 :  
=====================================================
*/
if(!defined('DATALIFEENGINE'))
{
  die("Hacking attempt!");
}

///////////////////////////////////////////////////////
// Function:     formatsize
// Description: Format the size of given file

function formatsize($file_size){
    if($file_size >= 1073741824)
        {$file_size = round($file_size / 1073741824 * 100) / 100 . " Gb";}
    elseif($file_size >= 1048576)
        {$file_size = round($file_size / 1048576 * 100) / 100 . " Mb";}
    elseif($file_size >= 1024)
        {$file_size = round($file_size / 1024 * 100) / 100 . " Kb";}
    else{$file_size = $file_size . " b";}
return $file_size;
}

function CheckCanGzip(){

if (headers_sent() || connection_aborted()){
return 0; 
}
if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') !== false) return "x-gzip"; 
if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) return "gzip"; 
return 0; 
}

function GzipOut(){
	global $Timer, $db;

echo "
<!--    ".$Timer->stop()."  -->
<!--     MySQL : ".round($db->MySQL_time_taken, 5)." -->
<!--   MySQL  ".$db->query_num." -->";

    $ENCODING = CheckCanGzip(); 
    if ($ENCODING){
        $Contents = ob_get_contents(); 
	 //$Contents=preg_replace('|<!--(.*?)-->|','',$Contents); 

        ob_end_clean(); 

        header("Content-Encoding: $ENCODING"); 
        print "\x1f\x8b\x08\x00\x00\x00\x00\x00"; 
        $Size = strlen($Contents); 
        $Crc = crc32($Contents); 
        $Contents = gzcompress($Contents, 1); 
        $Contents = substr($Contents,  0,  strlen($Contents) - 4); 
        print $Contents; 
        print pack('V', $Crc); 
        print pack('V', $Size); 
        exit; 
    }else{
//      ob_end_flush(); 
        exit; 
    }
}
///////////////////////////////////////////////////////
// Class:     microTimer
// Description: calculates the micro time

class microTimer {
    function start() {
        global $starttime;
        $mtime = microtime ();
        $mtime = explode (' ', $mtime);
        $mtime = $mtime[1] + $mtime[0];
        $starttime = $mtime;
    }
    function stop() {
        global $starttime;
        $mtime = microtime ();
        $mtime = explode (' ', $mtime);
        $mtime = $mtime[1] + $mtime[0];
        $endtime = $mtime;
        $totaltime = round (($endtime - $starttime), 5);
        return $totaltime;
    }
}

function allowed_ip ($ip) {
	global $_IP;

	$ip = trim($ip);

	if ($ip == "") { return true; }

    $blockip = FALSE;
            $ip_arr = rtrim($_IP);

            $ip_check_matches = 0;
            $db_ip_split = explode(".", $ip_arr);
            $this_ip_split = explode(".", $ip);

            for($i_i=0;$i_i<4;$i_i++){
                if ($this_ip_split[$i_i] == $db_ip_split[$i_i] OR $this_ip_split[$i_i] == '*') {
                    $ip_check_matches += 1;
                }

            }

            if ($ip_check_matches == 4) $blockip = TRUE;

	return $blockip;
}

function check_login($username, $md5_password){
    global $member_db, $db, $user_group, $lang, $domain;

	if ($username == "" OR $md5_password == "") return false;

$result = FALSE;

$username 	  = $db->safesql($username);
$md5_password = md5($md5_password);

	$db->query("SELECT * FROM " . PREFIX . "_users where name='$username' and password='$md5_password' and banned != 'yes'");

	while($row = $db->get_row())
	{

		$member_db[0] = $row['reg_date'];
		$member_db[1] = $row['user_group'];
		$member_db[2] = $row['name'];
		$member_db[5] = $row['email'];
		$member_db[6] = $row['news_num'];
		$member_db[7] = $row['allow_mail'];
		$member_db[10] = $row['user_id'];
		$member_db[11] = $row['fullname'];
		$member_db[12] = $row['land'];
		$member_db[13] = $row['icq'];
		$member_db[14] = $row['hash'];
		$member_db[15] = $row['logged_ip'];

		if (!allowed_ip ($row['allowed_ip'])) {

			$member_db = array();
			setcookie("dle_name","", time() - 3600, "/", $domain);
			setcookie("dle_password","", time() - 3600, "/", $domain);
			setcookie("dle_hash","", time() - 3600, "/", $domain);
			@session_destroy();
			@session_unset();
			setcookie(session_name(),"",time() - 3600, "/", $domain);

		msg("info", $lang['index_msge'], $lang['ip_block']);

		}

		if ($user_group[$row['user_group']]['allow_admin']) $result = TRUE; else $result = FALSE;

	}
	$db->free();

        return $result;
}


////////////////////////////////////////////////////////
// Function:     msg
// Description: Displays message to user

function msg($type, $title, $text, $back=FALSE){
global $lang;

  if($back){
        $back = "<br /><br/> <a class=main href=\"$back\">$lang[func_msg]</a>";
  }

  echoheader($type, $title);

echo <<<HTML
<div style="padding-top:5px;padding-bottom:2px;">
<table width="100%">
    <tr>
        <td width="4"><img src="engine/skins/images/tl_lo.gif" width="4" height="4" border="0"></td>
        <td background="engine/skins/images/tl_oo.gif"><img src="engine/skins/images/tl_oo.gif" width="1" height="4" border="0"></td>
        <td width="6"><img src="engine/skins/images/tl_ro.gif" width="6" height="4" border="0"></td>
    </tr>
    <tr>
        <td background="engine/skins/images/tl_lb.gif"><img src="engine/skins/images/tl_lb.gif" width="4" height="1" border="0"></td>
        <td style="padding:5px;" bgcolor="#FFFFFF">
<table width="100%">
    <tr>
        <td bgcolor="#EFEFEF" height="29" style="padding-left:10px;"><div class="navigation">{$title}</div></td>
    </tr>
</table>
<div class="unterline"></div>
<table width="100%">
    <tr>
        <td height="100" align="center">{$text} {$back}</td>
    </tr>
</table>
</td>
        <td background="engine/skins/images/tl_rb.gif"><img src="engine/skins/images/tl_rb.gif" width="6" height="1" border="0"></td>
    </tr>
    <tr>
        <td><img src="engine/skins/images/tl_lu.gif" width="4" height="6" border="0"></td>
        <td background="engine/skins/images/tl_ub.gif"><img src="engine/skins/images/tl_ub.gif" width="1" height="6" border="0"></td>
        <td><img src="engine/skins/images/tl_ru.gif" width="6" height="6" border="0"></td>
    </tr>
</table>
</div>
HTML;

  echofooter();
exit();
}

////////////////////////////////////////////////////////
// Function:    echoheader
// Description: Displays header skin

function echoheader($image, $header_text){
    global $PHP_SELF, $skin_header, $lang_content_type, $skin_menu, $skin_prefix, $member_db, $user_group;

    $skin_header = preg_replace("/{image-name}/", "${skin_prefix}${image}", $skin_header);
    $skin_header = preg_replace("/{header-text}/", $header_text, $skin_header);
    $skin_header = preg_replace("/{content-type}/", $lang_content_type, $skin_header);
    $skin_header = preg_replace("/{user}/", $member_db[2], $skin_header);    
    $skin_header = preg_replace("/{group}/", $user_group[$member_db[1]]['group_name'], $skin_header);    

    echo $skin_header;
}

////////////////////////////////////////////////////////
// Function:     echofooter
// Description: Displays footer skin

function echofooter(){

    global $PHP_SELF, $is_loged_in, $skin_footer, $lang_content_type, $skin_menu, $skin_prefix;

    $skin_footer = preg_replace("/{content-type}/", $lang_content_type, $skin_footer);

    echo $skin_footer;

}

////////////////////////////////////////////////////////
// Function:    ListDir
// Description: Delete the folder

function listdir($dir){

    $current_dir = opendir($dir);
    while($entryname = readdir($current_dir)){
        if(is_dir("$dir/$entryname") and ($entryname != "." and $entryname!="..")){
            listdir("${dir}/${entryname}");
        }elseif($entryname != "." and $entryname!=".."){
            unlink("${dir}/${entryname}");
        }
    }
    @closedir($current_dir);
    rmdir(${dir});
}

function totranslit($var)
{
        $NpjLettersFrom = "";
        $NpjLettersTo   = "abvgdeziklmnoprstufcy";
        $NpjBiLetters = array( 
      "" => "jj", "" => "jo", "" => "zh", "" => "kh", "" => "ch", 
      "" => "sh", "" => "shh", "" => "je", "" => "ju", "" => "ja",
      "" => "", "" => "",
                              );

        $NpjCaps  = "Ũ";
        $NpjSmall = "";

	  $var = trim(strip_tags($var));
      $var = preg_replace( "/\s+/ms", "_", $var );
      $var = strtr( $var, $NpjCaps, $NpjSmall );
      $var = strtr( $var, $NpjLettersFrom, $NpjLettersTo );
      $var = strtr( $var, $NpjBiLetters );

      $var = preg_replace("/[^a-z0-9_]+/mi", "", $var);
	  $var = strtolower ( $var );

  return $var;
}

////////////////////////////////////////////////////////
// Function:    LangDate
// Description: Changing of date by cyrillic equivalents
function langdate($format, $stamp){
  global $langdate;

  return strtr(date($format, $stamp), $langdate);

}


function CategoryNewsSelection($categoryid = 0, $parentid = 0, $nocat = TRUE, $sublevelmarker = '', $returnstring = '')
{
  global $cat, $cat_parentid, $member_db, $user_group;

 $allow_list = explode (',', $user_group[$member_db[1]]['allow_cats']);
 $spec_list = explode (',', $user_group[$member_db[1]]['cat_add']);

  if($parentid == 0) {
    if ($nocat) $returnstring .= '<option value="0"></option>';
  } else  {
    $sublevelmarker .= '&nbsp;&nbsp;&nbsp;&nbsp;';
  }
  if (isset($cat_parentid)) {

  $root_category = @array_keys($cat_parentid, $parentid);

  if (is_array($root_category)) {
  foreach ($root_category as $id) {
   $category_name = $cat[$id];

  if ($allow_list[0] == "all" OR in_array($id, $allow_list)) {

	if ($spec_list[0] == "all" OR in_array($id, $spec_list)) $color = "black"; else $color = "red";

   $returnstring .= "<option style=\"color: {$color}\" value=\"".$id.'" ';

   	if (is_array ($categoryid)){
		foreach ($categoryid as $element) {
		if($element == $id) $returnstring .= 'SELECTED';
		}
	}
	elseif($categoryid == $id) $returnstring .= 'SELECTED'; 

   $returnstring .= '>'.$sublevelmarker.$category_name.'</option>';
  }

    $returnstring = CategoryNewsSelection($categoryid, $id, $nocat, $sublevelmarker, $returnstring);
   }
  }
}
  return $returnstring;
}


function filesize_url($url){
   return ($data = @file_get_contents($url)) ? strlen($data) : false;
}


function clear_cache($cache_area = false){
	if ($cache_area){
	$filename = ENGINE_DIR.'/cache/'.$cache_area.'.tmp';
	@unlink($filename);
	} else {
	$fdir = opendir(ENGINE_DIR.'/cache');
    while ($file = readdir($fdir)){
        if ($file != '.' and $file != '..' and $file != '.htaccess' and $file != 'system'){
	                @unlink(ENGINE_DIR.'/cache/'.$file);

      	  }
  	  }
	}
}

 function xfieldsdataload ($id) {

  if ($id == "") return;

      $xfieldsdata = explode("||", $id);
      foreach ($xfieldsdata as $xfielddata) {
        list($xfielddataname, $xfielddatavalue) = explode("|", $xfielddata);
        $xfielddataname = str_replace("&#124;", "|", $xfielddataname);
        $xfielddataname = str_replace("__NEWL__", "\r\n", $xfielddataname);
        $xfielddatavalue = str_replace("&#124;", "|", $xfielddatavalue);
        $xfielddatavalue = str_replace("__NEWL__", "\r\n", $xfielddatavalue);
        $data[$xfielddataname] = $xfielddatavalue;
      }
    return $data;
 }

  function xfieldsload() {
  global $lang;
  $path = ENGINE_DIR.'/data/xfields.txt';
  $filecontents = file($path);

    if (!is_array($filecontents))
    msg("error", $lang['xfield_error'], "$lang[xfield_err_3] \"engine/data/xfields.txt\". $lang[xfield_err_4]");
  
    foreach ($filecontents as $name => $value) {
      $filecontents[$name] = explode("|", trim($value));
      foreach ($filecontents[$name] as $name2 => $value2) {
        $value2 = str_replace("&#124;", "|", $value2); 
        $value2 = str_replace("__NEWL__", "\r\n", $value2);
        $filecontents[$name][$name2] = htmlspecialchars($value2);
      }
    }
    return $filecontents;
  }

function create_metatags ($story) {
global $config, $db;

$keyword_count = 20;
$newarr = array ();
$headers = array ();
$quotes = array( "\x27", "\x22", "\x60", "\t",'\n','\r', "\n","\r", '\\', "'",",",".","/","","#",";",":","@","~","[","]","{","}","=","-","+",")","(","*","&","^","%","$","<",">","?","!", '"' );
$fastquotes = array( "\x27", "\x22", "\x60", "\t","\n","\r",'"',"'", '\r', '\n', "/", "\\");

  $story = preg_replace ("'\[hide\](.*?)\[/hide\]'si", "", $story);
  $story = str_replace('<br />', ' ', $story );
  $story = trim(strip_tags ($story));

  if (trim($_REQUEST['descr']) != "") {
   	  $headers['description'] = $db->safesql(substr(strip_tags(stripslashes($_REQUEST['descr'])), 0, 190));
  } else {
	$story = str_replace($fastquotes, '', $story );

	$headers['description'] = $db->safesql(substr($story, 0, 190));
  }

  if (trim($_REQUEST['keywords']) != "") {
	  $headers['keywords'] = $db->safesql(str_replace($fastquotes, " ", strip_tags(stripslashes($_REQUEST['keywords']))));
  } else {

	$story = str_replace($quotes, '', $story );

	$arr   = explode(" ", $story);

	foreach ($arr as $word) {
	if (strlen($word) > 4) $newarr [] = $word;
	}

	$arr   = array_count_values ($newarr);
	arsort ($arr);

	$arr = array_keys($arr);

	$total = count ($arr);

	$offset = 0;

	$arr =	array_slice ($arr, $offset, $keyword_count);

	$headers['keywords'] = $db->safesql(implode (", ", $arr));
  }

return $headers;
}

function set_vars ($file, $data){

	$filename = ENGINE_DIR.'/cache/system/'.$file.'.php';

    $fp = fopen($filename, 'wb+');
    fwrite($fp, serialize($data) );
    fclose($fp);

	@chmod($filename, 0666);
}

function get_vars ($file){
	$filename = ENGINE_DIR.'/cache/system/'.$file.'.php';

    if (!@filesize($filename)){
    	return false;
    }

	return unserialize(file_get_contents($filename));

}
function get_groups ($id = false){
     global $user_group;

	 $returnstring = "";

     foreach ($user_group as $group)
     {
   		$returnstring .= '<option value="'.$group['id'].'" ';

	if (is_array ($id)){
		foreach ($id as $element) {
		if($element == $group['id']) $returnstring .= 'SELECTED';
		}
	}
	elseif($id AND $id == $group['id']) $returnstring .= 'SELECTED'; 

		$returnstring .= ">".$group['group_name']."</option>\n";
	 }

	return $returnstring;

}
function permload ($id) {

	if ($id == "") return;

	$data = array();

      $groups = explode("|", $id);
      foreach ($groups as $group) {
        list($groupid, $groupvalue) = explode(":", $group);
		$data[$groupid][1] = ($groupvalue == 1) ? "selected" : "";
		$data[$groupid][2] = ($groupvalue == 2) ? "selected" : "";
		$data[$groupid][3] = ($groupvalue == 3) ? "selected" : "";
      }
    return $data;
}
function check_xss () {

	$url = html_entity_decode(urldecode($_SERVER['QUERY_STRING']));

	if ($url) {

		if ((strpos($url, '<') !== false) ||
			(strpos($url, '>') !== false) ||
			(strpos($url, '"') !== false) ||
			(strpos($url, './') !== false) ||
			(strpos($url, '../') !== false) ||
			(strpos($url, '\'') !== false) ||
			(strpos($url, '.php') !== false)
		   ) 
		{

		die("Hacking attempt!");
		}

	}

}

function clean_url ($url) {

  if ($url == '') return;

  $url = str_replace("http://", "", $url);
  if (strtolower(substr($url, 0, 4)) == 'www.')  $url = substr($url, 4);
  $url = reset(explode('/', $url));

  return $url;
}

function auth() {
    header('WWW-Authenticate: Basic realm="Admin Area"');
    header('HTTP/1.0 401 Unauthorized');
    echo "<H1>Access Denied</H1>";
    exit;
}
?>