<?PHP
/*
=====================================================
 : functions.inc.php
-----------------------------------------------------
 :  
=====================================================
*/
if(!defined('DATALIFEENGINE'))
{
  die("Hacking attempt!");
}

function formatsize($file_size){
    if($file_size >= 1073741824)
        {$file_size = round($file_size / 1073741824 * 100) / 100 . " Gb";}
    elseif($file_size >= 1048576)
        {$file_size = round($file_size / 1048576 * 100) / 100 . " Mb";}
    elseif($file_size >= 1024)
        {$file_size = round($file_size / 1024 * 100) / 100 . " Kb";}
    else{$file_size = $file_size . " b";}
return $file_size;
}

class microTimer {
    function start() {
        global $starttime;
        $mtime = microtime ();
        $mtime = explode (' ', $mtime);
        $mtime = $mtime[1] + $mtime[0];
        $starttime = $mtime;
    }
    function stop() {
        global $starttime;
        $mtime = microtime ();
        $mtime = explode (' ', $mtime);
        $mtime = $mtime[1] + $mtime[0];
        $endtime = $mtime;
        $totaltime = round (($endtime - $starttime), 5);
        return $totaltime;
    }
}

///////////////////////////////////////////////////////
// Function:    Flooder
// Description: Flood Protection Function

function flooder($ip){
    global $config, $db;

	$this_time = time() + ($config['date_adjust']*60) - $config['flood_time'];
	$db->query("DELETE FROM " . PREFIX . "_flood where id < '$this_time'");

	$sql_flood = "SELECT * FROM " . PREFIX . "_flood where id > '$this_time' and ip = '$ip'";

	if ($db->num_rows($db->query($sql_flood)) > 0) $result = TRUE; else $result = FALSE;

	$db->free();

    return $result;
}

///////////////////////////////////////////////////////
// Function:    query_string
// Description: Format the Query_String

function query_string($q_string, $strips, $type="get"){
	global $user;
	$my_q = ''; 

	if ($q_string == '') return;

    foreach($strips as $key){
        $strips[$key] = TRUE;
    }
    $var_value = explode("&", $q_string);

    foreach($var_value as $var_peace){
        $parts = explode("=", $var_peace);
		if ($parts[0] == "user") $parts[1] = urlencode($user);

        if((!isset($strips[$parts[0]]) OR $strips[$parts[0]] != TRUE) AND $parts[0] != ""){
            if($type == "post"){
                $my_q .= "<input type=\"hidden\" name=\"".$parts[0]."\" value=\"".$parts[1]."\" />\n";
            }else{
                $my_q .= $parts[0]."=".$parts[1]."&";
            }
        }
    }

if( substr($my_q, -5) == "&" ){ $my_q = substr($my_q, 0, -5); }

return $my_q;
}

////////////////////////////////////////////////////////
// Function:    ToTranslit
// Description: Transliteration cyrillic symbols

function totranslit($var)
{
        $NpjLettersFrom = "";
        $NpjLettersTo   = "abvgdeziklmnoprstufcy";
        $NpjBiLetters = array( 
      "" => "jj", "" => "jo", "" => "zh", "" => "kh", "" => "ch", 
      "" => "sh", "" => "shh", "" => "je", "" => "ju", "" => "ja",
      "" => "", "" => "",
                              );

        $NpjCaps  = "Ũ";
        $NpjSmall = "";

	  $var = trim(strip_tags($var));
      $var = preg_replace( "/\s+/ms", "_", $var );
      $var = strtr( $var, $NpjCaps, $NpjSmall );
      $var = strtr( $var, $NpjLettersFrom, $NpjLettersTo );
      $var = strtr( $var, $NpjBiLetters );

      $var = preg_replace("/[^a-z0-9_]+/mi", "", $var);
	  $var = strtolower ( $var );

  return $var;
}

////////////////////////////////////////////////////////
// Function:    LangDate
// Description: Changing of date by cyrillic equivalents
function langdate($format, $stamp){
  global $langdate;

  return strtr(date($format, $stamp), $langdate);

}

////////////////////////////////////////////////////////
// Function: 	word_filter
// Description: Filter comments, add news and/or edit news
function word_filter($source) {

	@setlocale(LC_CTYPE, array("ru_RU.CP1251", "ru_SU.CP1251", "ru_RU.KOI8-r", "ru_RU", "russian", "ru_SU", "ru"));

	$all_words = file(ENGINE_DIR.'/data/wordfilter.db.php');

if (count($all_words)) {
	foreach($all_words as $word_line)
	{
		$word_arr = explode("|", $word_line);

		$find[] = "#(".$word_arr[1].")#i";
		$replace[] = $word_arr[2];

	}

	$source = preg_replace($find,$replace,$source);
}
	return $source;
}
////////////
// Declare the function
function msgbox($title, $text){
global $tpl;

$tpl->load_template('info.tpl');

$tpl->set('{error}', $text);
$tpl->set('{title}', $title);

  $tpl->compile('info');
  $tpl->clear();
}


function ShowRating ($id, $rating, $vote_num){
global $is_logged, $member_id, $config, $lang, $db;


$excellent = $lang['excellent'];
$good = $lang['good'];
$fair = $lang['fair'];
$poor = $lang['poor'];
$useless = $lang['useless'];

$rated = "<div class=\"rating\" style=\"width: 84px; height: 52px;\"><br/>\n";

if ($rating) $rating = round(($rating /  $vote_num), 0); else $rating = 0;
//$rating = $rating * 17;

if ($_SERVER['HTTP_X_FORWARDED_FOR']) $_IP = $db->safesql($_SERVER['HTTP_X_FORWARDED_FOR']); else $_IP = $db->safesql($_SERVER['REMOTE_ADDR']);

if ($rating){
  if ($is_logged) $where = "member = '{$member_id['name']}'";
  else $where = "ip ='{$_IP}'";

  $row = $db->super_query("SELECT news_id FROM " . PREFIX . "_logs where news_id ='$id' AND {$where}");
} else $row['news_id'] = false;

if (!$row['news_id']){

$rated .= <<<HTML
<div class="rating">
<a href="/rate/{$id}/1">1</a> | <a href="/rate/{$id}/2">2</a> | <a href="/rate/{$id}/3">3</a> | <a href="/rate/{$id}/4">4</a> | <a href="/rate/{$id}/5">5</a></div>
<div class="rating">&nbsp;({$lang['voten']} {$vote_num})</div>
HTML;
        
} else {

$rated .= <<<HTML
<div class="rating">{$rating}<br/></div>
<div class="rating">&nbsp;({$lang['voten']} {$vote_num})</div>
HTML;



}

$rated  .= "</div>\n";


return $rated;
}


function ShortRating ($rating, $vote_num){
global $config, $lang;

$rated = "";

$excellent = $lang['excellent'];
$good = $lang['good'];
$fair = $lang['fair'];
$poor = $lang['poor'];
$useless = $lang['useless'];

if ($rating < 1){
    $rated  .= "<img src=\"".$config['http_home_url']."templates/{$config['skin']}/dleimages/rating0.gif\"  alt=\"0\"/>\n";

} else {
$rating = round(($rating /  $vote_num), 0);

if ($rating == 1) {
    $rated  .= "<img src=\"".$config['http_home_url']."templates/{$config['skin']}/dleimages/rating1.gif\" alt=\"$lang[rated] $useless\"/>\n";
}elseif ($rating == 2) {
    $rated  .= "<img src=\"".$config['http_home_url']."templates/{$config['skin']}/dleimages/rating2.gif\" alt=\"$lang[rated] $poor\"/>\n";
}elseif ($rating == 3) {
    $rated  .= "<img src=\"".$config['http_home_url']."templates/{$config['skin']}/dleimages/rating3.gif\" alt=\"$lang[rated] $fair\"/>\n";
}elseif ($rating == 4) {
    $rated  .= "<img src=\"".$config['http_home_url']."templates/{$config['skin']}/dleimages/rating4.gif\" alt=\"$lang[rated] $good\"/>\n";
}elseif ($rating == 5) {
    $rated  .= "<img src=\"".$config['http_home_url']."templates/{$config['skin']}/dleimages/rating5.gif\" alt=\"$lang[rated] $excellent\"/>\n";
}
}

return $rated;
}


function userrating ($name){
global $db;

$row = $db->super_query("SELECT SUM(rating) as rating, SUM(vote_num) as num FROM " . PREFIX . "_post where autor ='$name'");

if ($row['num']) $rating = round(($row['rating'] /  $row['num']), 0); else $rating = 0;
$rating = $rating * 17;

$rated = <<<HTML
{$rating}
HTML;

return $rated;
}

function CategoryNewsSelection($categoryid = 0, $parentid = 0, $nocat = TRUE, $sublevelmarker = '', $returnstring = '')
{ 
  global $cat_info, $user_group, $member_id;

 $allow_list = explode (',', $user_group[$member_id['user_group']]['allow_cats']);
 $spec_list = explode (',', $user_group[$member_id['user_group']]['cat_add']);
 $root_category = array();

  if($parentid == 0) {
    if ($nocat) $returnstring .= '<option value="0"></option>';
  } else  {
    $sublevelmarker .= '&nbsp;&nbsp;&nbsp;';
  }

  if (count($cat_info)) {

  foreach ($cat_info as $cats) {
   if ($cats['parentid'] == $parentid) $root_category[] = $cats['id'];
  }

  if (count($root_category)) {
  foreach ($root_category as $id) {

  if ($allow_list[0] == "all" OR in_array($id, $allow_list)) {

	if ($spec_list[0] == "all" OR in_array($id, $spec_list)) $color = "dark"; else $color = "red";

   $returnstring .= "<option style=\"color: {$color}\" value=\"".$id.'" ';

   	if (is_array ($categoryid)){
		foreach ($categoryid as $element) {
		if($element == $id) $returnstring .= 'SELECTED';
		}
	}
	elseif($categoryid == $id) $returnstring .= 'SELECTED'; 

   $returnstring .= '>'.$sublevelmarker.$cat_info[$id]['name'].'</option>';
  }
    $returnstring = CategoryNewsSelection($categoryid, $id, $nocat, $sublevelmarker, $returnstring);
   }
  }
}
  return $returnstring;
}

function get_ID ($cat_info, $category){
  foreach ($cat_info as $cats) {
   if ($cats['alt_name'] == $category) return $cats['id'];
  }
return false;
}

function set_vars ($file, $data){

    $fp = fopen(ENGINE_DIR.'/cache/system/'.$file.'.php', 'wb+');
    fwrite($fp, serialize($data) );
    fclose($fp);

	@chmod($filename, 0666);
}

function get_vars ($file){

	return unserialize(@file_get_contents(ENGINE_DIR.'/cache/system/'.$file.'.php'));
}

function filesize_url($url){
   return ($data = @file_get_contents($url)) ? strlen($data) : false;
}

function dle_cache($prefix, $cache_id=false, $member_prefix=false){
  global $config, $is_logged, $member_id;

	if ($config['allow_cache'] != "yes") return false;

	if ($is_logged) $end_file = $member_id['user_group']; else $end_file = "0";

	if ($cache_id == false) {
	$filename = ENGINE_DIR.'/cache/'.$prefix.'.tmp';	
	} else {
	$cache_id = totranslit ($cache_id);

		if ($member_prefix)
	$filename = ENGINE_DIR."/cache/".$prefix."_".$cache_id."_".$end_file.".tmp";
		else
	$filename = ENGINE_DIR."/cache/".$prefix."_".$cache_id.".tmp";

	}

    if (!@filesize($filename)){
    	return false;
    }

	$cache = gzuncompress (file_get_contents($filename));

return $cache;
}

function create_cache($prefix, $cache_text, $cache_id=false, $member_prefix=false){
  global $config, $is_logged, $member_id;

		if ($config['allow_cache'] != "yes") return false;

	if ($is_logged) $end_file = $member_id['user_group']; else $end_file = "0";


	if ($cache_id == false) {
	$filename = ENGINE_DIR.'/cache/'.$prefix.'.tmp';	
	} else {
	$cache_id = totranslit ($cache_id);

		if ($member_prefix)
	$filename = ENGINE_DIR."/cache/".$prefix."_".$cache_id."_".$end_file.".tmp";
		else
	$filename = ENGINE_DIR."/cache/".$prefix."_".$cache_id.".tmp";

	}

    $fp = fopen($filename, 'wb+');
    fwrite($fp, gzcompress($cache_text, 1));
    fclose($fp);

	@chmod($filename, 0666);

}

function clear_cache($cache_area = false){
global $config;

	if ($cache_area){
	$filename = ENGINE_DIR.'/cache/'.$cache_area.'.tmp';
	@unlink($filename);
	} else {
	$fdir = opendir(ENGINE_DIR.'/cache');
    while ($file = readdir($fdir)){
        if ($file != '.' and $file != '..' and $file != '.htaccess' and $file != 'system'){
	                @unlink(ENGINE_DIR.'/cache/'.$file);

      	  }
  	  }
	}
}

function ChangeSkin($dir, $skin){

global $PHP_SELF;

        $templates_list = array();

        $handle = opendir($dir);

           while (false !== ($file = readdir($handle))){
				if(is_dir("./templates/$file") and ($file != "." and $file!="..")){
            $templates_list[] = $file;
        }
          }
        closedir($handle);

	$skin_list = "<form method=\"post\" action=\"$PHP_SELF\"><fieldset><select name=\"skin_name\">";

        foreach($templates_list as $single_template){
			if ($single_template == $skin) $selected = " selected=\"selected\""; else $selected = "";
            $skin_list .= "<option value=\"$single_template\"".$selected.">$single_template</option>";
        }
        $skin_list .= '</select><input type="hidden" name="action_skin_change" value="yes"/>
        <input class="ibutton" type="submit" value=""/></fieldset></form>';

return $skin_list;
} 

function custom_print ($custom_category, $custom_template, $aviable, $custom_from, $custom_limit, $custom_cache, $do){
global $db, $is_logged, $member_id, $xf_inited, $cat_info, $config, $user_group, $category_id;


	$do = $do ? $do : "main";
	$aviable = explode ('|', $aviable);

	if(!(in_array($do, $aviable)) AND ($aviable[0] != "global")) return "";

	$custom_category  = $db->safesql(str_replace(',', '|', $custom_category));
	$custom_from = intval($custom_from);
	$custom_limit = intval($custom_limit);
	$thisdate = date ("Y-m-d H:i:s", (time()+ $config['date_adjust']*60));
	$content = false;

	$tpl = new dle_template;
	$tpl->dir = TEMPLATE_DIR;

	if ($custom_cache == "yes") $config['allow_cache'] = "yes"; else $config['allow_cache'] = false;
	if ($is_logged AND ($user_group[$member_id['user_group']]['allow_edit'] AND !$user_group[$member_id['user_group']]['allow_all_edit'])) $config['allow_cache'] = false;

	$content = dle_cache("custom", $custom_category.$custom_template.$custom_from, true);

	if ($content) { return $content; }
	else {
	$allow_list = explode (',', $user_group[$member_id['user_group']]['allow_cats']);
	if ($allow_list[0] != "all") $stop_list = "category regexp '[[:<:]](".implode ('|', $allow_list).")[[:>:]]' AND "; else $stop_list = "";

	if ($user_group[$member_id['user_group']]['allow_short']) $stop_list = "";

	if ($cat_info[$custom_category]['news_sort'] != "") $config['news_sort'] = $cat_info[$custom_category]['news_sort'];
	if ($cat_info[$custom_category]['news_msort'] != "") $config['news_msort'] = $cat_info[$custom_category]['news_msort'];


    $sql_select = "SELECT id, autor, date, short_story, full_story, xfields, title, category, alt_name, comm_num, allow_comm, allow_rate, rating, vote_num, news_read FROM " . PREFIX . "_post where {$stop_list}category regexp '[[:<:]]($custom_category)[[:>:]]' AND approve = '1' AND date < '$thisdate' order by ".$config['news_sort']." ".$config['news_msort']." LIMIT ".$custom_from.",".$custom_limit;
	include(ENGINE_DIR.'/modules/show.custom.php');

		if ($config['files_allow'] == "yes")
			if ( stristr( $tpl->result['content'], "[attachment=" ) )
			{
				$tpl->result['content'] = show_attach($tpl->result['content'], $attachments);
			}

	create_cache("custom", $tpl->result['content'], $custom_category.$custom_template.$custom_from, true);

	}
	return $tpl->result['content'];
}

function check_module ($aviable, $block, $do) {

	$do = $do ? $do : "main";
	$aviable = explode ('|', $aviable);

	$block = str_replace("&", "&", $block);
	$block = str_replace('\"', '"', $block);

	if(!(in_array($do, $aviable)) AND ($aviable[0] != "global")) return "";
	else return $block;

}

function check_ip ($ips) {

	if ($_SERVER['HTTP_X_FORWARDED_FOR']) $_IP = $_SERVER['HTTP_X_FORWARDED_FOR']; else $_IP = $_SERVER['REMOTE_ADDR'];

    $blockip = FALSE;

  if (is_array($ips)) {
    foreach($ips as $ip_line){

          $ip_arr = rtrim($ip_line['ip']);

            $ip_check_matches = 0;
            $db_ip_split = explode(".", $ip_arr);
            $this_ip_split = explode(".", $_IP);

            for($i_i=0;$i_i<4;$i_i++){
                if ($this_ip_split[$i_i] == $db_ip_split[$i_i] OR $db_ip_split[$i_i] == '*') {
                    $ip_check_matches += 1;
                }

            }

            if ($ip_check_matches == 4) { $blockip = $ip_line['ip']; break;}

    }
  }

	return $blockip;
}

function show_attach ($story, $id) {
global $db, $config, $lang, $user_group, $member_id;

 if (is_array($id) AND count($id))
	$where = "news_id IN (".implode(",", $id).")";
 else
	$where = "news_id = '$id'";
 
    $db->query("SELECT id, name, onserver, dcount FROM " . PREFIX . "_files WHERE $where");

	while($row = $db->get_row()){
	
	$size = formatsize(@filesize ( ROOT_DIR . '/uploads/files/' . $row['onserver'] ));

     if (!$user_group[$member_id['user_group']]['allow_files'])
		$link = "{$lang['att_denied']}";
	 elseif ($config['files_count'] == 'yes')
		$link = "<a href=\"{$config['http_home_url']}engine/download.php?id={$row['id']}\" >{$row['name']}</a> [{$size}] ({$lang['att_dcount']} {$row['dcount']}";
	  else
		$link = "<a href=\"{$config['http_home_url']}engine/download.php?id={$row['id']}\" >{$row['name']}</a> [{$size}]";

		$story = str_replace( '[attachment='.$row['id'].']', $link, $story );
	}
	$db->free();

	return $story;

}

function xfieldsload($profile = false) {
  global $lang;

  if ($profile) $path = ENGINE_DIR.'/data/xprofile.txt';
  else $path = ENGINE_DIR.'/data/xfields.txt';

  $filecontents = file($path);

    if (!is_array($filecontents))
    msgbox("System error", "File <b>{$path}</b> not found");
   else {
    foreach ($filecontents as $name => $value) {
      $filecontents[$name] = explode("|", trim($value));
      foreach ($filecontents[$name] as $name2 => $value2) {
        $value2 = str_replace("&#124;", "|", $value2); 
        $value2 = str_replace("__NEWL__", "\r\n", $value2);
        $filecontents[$name][$name2] = $value2;
      }
    }
  }
    return $filecontents;
}

function xfieldsdataload ($id) {

if ($id == "") return;

      $xfieldsdata = explode("||", $id);
      foreach ($xfieldsdata as $xfielddata) {
        list($xfielddataname, $xfielddatavalue) = explode("|", $xfielddata);
        $xfielddataname = str_replace("&#124;", "|", $xfielddataname);
        $xfielddataname = str_replace("__NEWL__", "\r\n", $xfielddataname);
        $xfielddatavalue = str_replace("&#124;", "|", $xfielddatavalue);
        $xfielddatavalue = str_replace("__NEWL__", "\r\n", $xfielddatavalue);
        $data[$xfielddataname] = $xfielddatavalue;
      }
    return $data;
}

function create_keywords ($story) {
global $metatags;

$keyword_count = 20;
$newarr = array ();
$quotes = array( "\x27", "\x22", "\x60", "\t","\n","\r","'",",",".","/","","#",";",":","@","~","[","]","{","}","=","-","+",")","(","*","&","^","%","$","<",">","?","!", '"' );
$fastquotes = array( "\x27", "\x22", "\x60", "\t","\n","\r",'"',"'", "\\", '\r', '\n', "/");

	$story = preg_replace ("'\[hide\](.*?)\[/hide\]'si", "", $story);
	$story = str_replace($fastquotes, '', trim(strip_tags(str_replace('<br />', ' ', stripslashes($story)))));

	$metatags['description'] = substr($story, 0, 190);

	$story = str_replace($quotes, '', $story );

	$arr   = explode(" ", $story);

	foreach ($arr as $word) {
	if (strlen($word) > 4) $newarr [] = $word;
	}

	$arr   = array_count_values ($newarr);
	arsort ($arr);

	$arr = array_keys($arr);

	$total = count ($arr);

	$offset = 0;

	$arr =	array_slice ($arr, $offset, $keyword_count);

	$metatags['keywords'] = implode (", ", $arr);
}

function allowed_ip ($ip) {

	$ip = trim($ip);

	if ($ip == "") { return true; }

    $blockip = FALSE;
	if ($_SERVER['HTTP_X_FORWARDED_FOR']) $ip_arr = $_SERVER['HTTP_X_FORWARDED_FOR']; else $ip_arr = $_SERVER['REMOTE_ADDR'];

            $ip_check_matches = 0;
            $db_ip_split = explode(".", $ip_arr);
            $this_ip_split = explode(".", $ip);

            for($i_i=0;$i_i<4;$i_i++){
                if ($this_ip_split[$i_i] == $db_ip_split[$i_i] OR $this_ip_split[$i_i] == '*') {
                    $ip_check_matches += 1;
                }

            }

            if ($ip_check_matches == 4) $blockip = TRUE;

	return $blockip;
}

function check_group ($groups, $block) {
	global $member_id;

	$groups = explode (',', $groups);

	if(!in_array($member_id['user_group'], $groups)) return "";

	$block = str_replace('\"', '"', str_replace("&", "&", $block));

	return $block;

}

function news_permission ($id) {

	if ($id == "") return;

	$data = array();

      $groups = explode("|", $id);
      foreach ($groups as $group) {
        list($groupid, $groupvalue) = explode(":", $group);
		$data[$groupid] = $groupvalue;
      }
    return $data;
}

function bannermass($fest,$massiv) {
		 return $fest.$massiv[@array_rand($massiv)]['text'];
}

function get_sub_cats ($id, $subcategory = '') {

	global $cat_info;
	$subfound = array ();

	if ($subcategory == '') $subcategory = $id;

     foreach ($cat_info as $cats)
     {
       if ($cats['parentid'] == $id) { $subfound[] = $cats['id']; }
     }

	foreach ($subfound as $parentid)
	{
		$subcategory .= "|".$parentid;
		$subcategory = get_sub_cats($parentid, $subcategory);
	}

return $subcategory;

}

function check_xss () {

	$url = html_entity_decode(urldecode($_SERVER['QUERY_STRING']));

	if ($url) {

		if ((strpos($url, '<') !== false) ||
			(strpos($url, '>') !== false) ||
			(strpos($url, '"') !== false) ||
			(strpos($url, './') !== false) ||
			(strpos($url, '../') !== false) ||
			(strpos($url, '\'') !== false) ||
			(strpos($url, '.php') !== false)
		   ) 
		{

		die("Hacking attempt!");
		}

	}

}

function check_category ($cats, $block, $category) {

	$cats = explode (',', $cats);

	if(!in_array($category, $cats)) return "";

	$block = str_replace('\"', '"', str_replace("&", "&", $block));

	return $block;

}

function clean_url ($url) {

  if ($url == '') return;

  $url = str_replace("http://", "", $url);
  if (strtolower(substr($url, 0, 4)) == 'www.')  $url = substr($url, 4);
  $url = reset(explode('/', $url));

  return $url;
}

// maqk function ;) 
function DispCategories()
{
global $category_id;
$file=get_vars('category');	

if($category_id==0)
{
	foreach ($file as $cat)
	if(!$cat['parentid'])
$data.= "&#187; <a href=\"/category/".$cat[alt_name]."/\">".$cat[name]."</a><br/>\n";
}
else if($category_id>0)
{
foreach ($file as $cat)
if($cat['parentid']==$category_id)
$data.= "&#187; <a href=\"/category/".$cat[alt_name]."/\">".$cat[name]."</a><br/>\n";
}
else return NULL;
	
	return $data;
}
?>