<?
/*
=====================================================
 : gzip.php
-----------------------------------------------------
 :  gzip
=====================================================
*/
if(!defined('DATALIFEENGINE'))
{
  die("Hacking attempt!");
}

function CheckCanGzip(){

if (headers_sent() || connection_aborted()){
return 0; 
}
if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'x-gzip') !== false) return "x-gzip"; 
if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) return "gzip"; 
return 0; 
}

function replace_ampersant($url){	
	return "<a href=\"".str_replace("&","&amp;",$url[1])."\">";	
}

/* $level = compression level 0-9,  0=none,  9=max */
function GzipOut($debug=0, $level=1){
	global $config, $Timer, $db, $tpl;

$s = "
<!-- gen ".$Timer->stop()." sec template ".round($tpl->template_parse_time, 5)." sec MySQL ".$db->query_num." (".round($db->MySQL_time_taken, 5).") -->";

$s2= "
<--    ".$Timer->stop()."  --><br/>
<--      ".round($tpl->template_parse_time, 5)."  --><br/>
<--     MySQL : ".round($db->MySQL_time_taken, 5)." --><br/>
<--   MySQL  ".$db->query_num." -->";

@header ("Last-Modified: " . date('r', time()-60*60*10) ." GMT");

if ($config['allow_gzip'] != "yes") 
	{if ($debug) 
		echo $s; 
		//ob_end_flush(); 
		$Contents = ob_get_contents();
    ob_end_clean();
    if($config['charset']=='utf-8') $Contents=iconv('windows-1251','utf-8',$Contents);
    $Contents=preg_replace_callback ("#<a .*?href=\"(.*?)\">#is","replace_ampersant", $Contents);    
    $Contents=preg_replace ("# id=[\"'].*?[\"']#is",'', $Contents);
    $Contents=preg_replace('|<!--(.*?)-->|','',$Contents); 
    echo $Contents;
		return;}

    $ENCODING = CheckCanGzip(); 
    if ($ENCODING){
        $s .= "\n<!--     $ENCODING -->\n"; 
        $Contents = ob_get_contents(); 
        ob_end_clean(); 
        if ($debug){
            $s .= "<!--   : ".strlen($Contents)."  "; 
            $s .= " : ".
                   strlen(gzcompress($Contents, $level)).
                   "  -->"; 
            $Contents .= $s; 
        }
        header("Content-Encoding: $ENCODING"); 
        print "\x1f\x8b\x08\x00\x00\x00\x00\x00"; 
        $Size = strlen($Contents); 
        $Crc = crc32($Contents); 
        $Contents = gzcompress($Contents, $level); 
        $Contents = substr($Contents,  0,  strlen($Contents) - 4); 
        print $Contents; 
        print pack('V', $Crc); 
        print pack('V', $Size); 
        exit; 
    }else{    		
        //ob_end_flush(); 
        $Contents = ob_get_contents();
        ob_end_clean();
        if($config['charset']=='utf-8') $Contents=iconv('windows-1251','utf-8',$Contents);
        $Contents=preg_replace_callback ("#<a .*?[href|action]=\"(.*?)\">#is","replace_ampersant", $Contents);
        $Contents=preg_replace ("# id=[\"'](.*?)[\"']#is",'', $Contents);
	 $Contents=preg_replace('|<!--(.*?)-->|','',$Contents); 
        echo $Contents;
        exit; 
    }
}
?>